package weaver.interfaces.organization.cronJob;

import com.engine.organization.entity.map.JclOrgMap;
import com.engine.organization.mapper.jclorgmap.JclOrgMapper;
import com.engine.organization.mapper.staff.StaffMapper;
import com.engine.organization.util.OrganizationDateUtil;
import com.engine.organization.util.db.MapperProxyFactory;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import weaver.conn.RecordSet;
import weaver.general.Util;
import weaver.interfaces.schedule.BaseCronJob;

import java.sql.Date;
import java.util.List;

/**
 * 定时任务刷新在岗数、编制数
 */
public class JobAndPlanCron extends BaseCronJob {

    private static final Logger LOGGER = LoggerFactory.getLogger("chartDataLog");

    char separator = Util.getSeparator();

    private JclOrgMapper getJclOrgMapMapper(){
        return MapperProxyFactory.getProxy(JclOrgMapper.class);
    }

    private StaffMapper getStaffMapper() {
        return MapperProxyFactory.getProxy(StaffMapper.class);
    }
    @Override
    public void execute() {
        // 计划任务需要处理的逻辑
        RecordSet recordSet = new RecordSet();
        String fType = "3";
        String currentDate = OrganizationDateUtil.getFormatLocalDate(new java.util.Date());
        List<JclOrgMap> jclOrgMaps = getJclOrgMapMapper().getJclOrgMapByType(fType,new java.sql.Date(OrganizationDateUtil.stringToDate(currentDate).getTime()));

        for (JclOrgMap jclOrgMap : jclOrgMaps){
            String id = String.valueOf(jclOrgMap.getId());

        }

    }

    /**
     * 刷新在岗数
     */
    void countJobs(String type,int id,String currentDate) {
        //找上级
        RecordSet rs = new RecordSet();
        String sql = "select fparentid from jcl_org_map where ftype=? and id=? and fdateend>?";
        String typeSql = "select ftype from jcl_org_map where id=? and fdateend>?";
        rs.executeQuery(sql, type, currentDate);
        String fparentid = null;
        String ftype = null;
        if (rs.next()) {
            fparentid = rs.getString("fparentid");
            rs.executeQuery(typeSql, fparentid, currentDate);
            if (rs.next()) {
                ftype = rs.getString("ftype");
            }
        }
        JclOrgMap jclOrgMap = getJclOrgMapMapper().getSumPlanAndJobByFParentId(new Date(OrganizationDateUtil.stringToDate(currentDate).getTime()), fparentid);
        getJclOrgMapMapper().updateMapById(Integer.parseInt(fparentid), jclOrgMap.getFPlan(), jclOrgMap.getFOnJob(), new Date(OrganizationDateUtil.stringToDate(currentDate).getTime()));

        if (fparentid.equals("-1")) {
            countJobs(ftype, Integer.parseInt(fparentid), currentDate);
        }

    }
    /**
     * 刷新编制数
     */
    void countPlans(String type,int id,String currentDate) {
        //找上级
        RecordSet rs = new RecordSet();
        String sql = "select fparentid from jcl_org_map where ftype=? and id=? and fdateend>?";
        String typeSql = "select ftype from jcl_org_map where id=? and fdateend>?";
        rs.executeQuery(sql, type, currentDate);
        String fparentid = null;
        String ftype = null;
        if (rs.next()) {
            fparentid = rs.getString("fparentid");
            rs.executeQuery(typeSql, fparentid, currentDate);
            if (rs.next()) {
                ftype = rs.getString("ftype");
            }
        }
//        JclOrgMap jclOrgMap

    }

}
